////  ~/siRNA/src/rational_split/rational_split.cpp ////
//// splitting the dataset into training sets and test sets according to the art2a output
////this algorithm shuffle the index within each cluster, then pick C.id[0] from each cluster as testset molecules.

#include <float.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <sstream>
#include <iostream>
#include <fstream>
#include <ctime> 
#include <time.h>
#include <cstdlib>

#define MAX_DESC 252//max # of descriptors(total BCUTs) 
#define MAX_MOL 2500//max # of siRNAs in the dataset
#define MAX_POSE 1//max # of poses per siRNA
#define MAX_MEM 200//max # of siRNAs in a cluster
#define MAX_TMOL 500//max # of siRNAs in test set

using namespace std;
using std::string;

class sirna{ //define a molecule in the QSAR table
public:
	std::string seq;//sequence of a siRNA
	double act; //activity data
	double desc[MAX_DESC]; //descriptor array
};

class cluster{ //define a cluster
public:
        int n_mem; //# of members in the cluster
        int id[MAX_MEM]; //ID array of the cluster members
	void shuff_d();
};

void cluster::shuff_d(){
	srand((unsigned)time(0));//initialize seed "randomly"
	int r;//random remaining position
	int tmp;
	for (int i=0; i<n_mem; i++){
		r=(rand() % n_mem);//Random remaining position.
		tmp = id[i];
		id[i] = id[r];
		id[r] = tmp;
	}
}


int main(int argc, char *argv[] ){
   int n_mol;//# of siRNAs in whole dataset
//   int n_pose;//# of poses per molecule
   int n_desc;//# of descriptors (total BCUTs)
   int n_split;//# of splitting
   int n_tmol;//# of siRNAs in test set
   double max_act;//max activity among the dataset
   double min_act;//min activity among the dataset
   int n_set;//# of testing sets
   int flag;//flag=0, testset; flag=1, training set 
   int t[MAX_TMOL]; //holding the ids of siRNAs in the testset
   sirna S[MAX_MOL];//holding all the sar data
   cluster C[MAX_TMOL];//holding all the clusters
   
	////read commend line

   n_mol = atoi(argv[1]);
   n_desc = atoi(argv[2]);
   n_split = atoi(argv[3]);
   n_tmol = atoi(argv[4]);

	//// read clusters////
   for (int i=0; i<n_tmol; i++){

	   cin >>C[i].n_mem;
	   for (int j=0; j<C[i].n_mem; j++){
		cin >>C[i].id[j];
           }
   }
   
    //// read sequence data////
    for(int i=0; i< n_mol; i++) {//loop on all the siRNAs

        cin >> S[i].seq;
    }


    //// read activity data////
    for(int i=0; i< n_mol; i++) {//loop on all the siRNAs
	
	cin >> S[i].act;
    }

    ////read descriptor data
    for (int i=0; i<n_mol; i++){//loop on siRNAs of the dataset
	for (int j=0;j<n_desc; j++){//loop on descriptors of a siRNA
			cin >> S[i].desc[j];
	}
    }

    ////calc max_act and min_act////
    max_act = S[0].act;
    min_act = S[0].act;
    for (int i=0; i<n_mol; i++){
	if (S[i].act >max_act){
		max_act=S[i].act;
	}
	else if (S[i].act <min_act){
		min_act=S[i].act;
	}
   }
   cout <<"max_act=" <<max_act<<" "<<"min_act="<<min_act<<endl;
   ////split the dataset into testset and training set////
   for (int n_set=0; n_set<n_split; n_set++){//loop on splitting
	for (int i=0; i<n_tmol; i++){//loop on clusters
       		C[i].shuff_d();
   		t[i]=C[i].id[1];
		if((S[t[i]-1].act) == max_act||(S[t[i]-1].act) == min_act){
			t[i]=C[i].id[0];
		}
		if((S[t[i]-1].act) == max_act||(S[t[i]-1].act) == min_act){
                	cout << "cluster "<<i<<" is unreasonable!"<<endl;
			exit(1);
       		 }
	}


	////output testset Ids
	cout<<"test_set_ids"<<n_set;
	for (int i=0; i<n_tmol; i++){//loop on clusters
		cout<<" "<<t[i];
	}
	cout<<endl;

	////output testset 
	for (int i=0; i<n_tmol; i++){//loop on siRNAs in the testset

		cout<<"test_set"<<n_set<<":";
		cout<<" "<<S[t[i]-1].seq;
		cout<<" "<<S[t[i]-1].act;
		for (int j=0; j<n_desc; j++){//loop on descriptors of a siRNA
			cout<<" "<<S[t[i]-1].desc[j];
		}
		cout<<endl;
	}

	////output training set
        
	for (int i=0; i<n_mol; i++){//loop on siRNAs in the dataset
	    flag=1;
            for (int it=0;it<n_tmol;it++){//loop on all the siRNAs in the testset
	    	if (i==(t[it]-1)){//siRNA i belongs to test set
                        flag=0;
			break;
                }
            } 
            if (flag==1){//siRNA i belong to training set
			cout<<"train_set_ids"<<n_set;
			cout<<" "<<i+1<<endl;
			cout<<"train_set"<<n_set<<":";
			cout<<" "<<S[i].seq;
			cout<<" "<<S[i].act;
			for(int j=0;j<n_desc;j++){
				cout<<" "<<S[i].desc[j];
			}
			cout<<endl;
            }
       }
					
   }//end of splitting
}//end of main

